/* Copyright(C) Jonas 'Sortie' Termansen 2012, 2013. */
/* Insert regular GCC licence information here with proper exceptions. */

/* The Sortix standard library does what glibc does, so copied from gnu-user. */

#undef TARGET_SORTIX
#define TARGET_SORTIX 1

/* Don't automatically add extern "C" { } around header files.  */
#undef  NO_IMPLICIT_EXTERN_C
#define NO_IMPLICIT_EXTERN_C 1

/* Do the same crt stuff as GNU - except that crt0.o is now crt1.o and I don't
   actually implement (or understand) all of this yet. For normal statically
   linked programs, we link in the order: crt1.o, crti.o, crtbegin.o,
   myprog-foo.o, myprog-bar.o, crtend.o, and crtn.o. */

/* Objects automatically prepended to the link command line. */
#undef  STARTFILE_SPEC
#if defined(HAVE_LD_PIE)
#define STARTFILE_SPEC \
  "%{!shared: %{pg|p|profile:gcrt1.o%s;pie:Scrt1.o%s;:crt1.o%s}} \
   crti.o%s %{static:crtbeginT.o%s;shared|pie:crtbeginS.o%s;:crtbegin.o%s}"
#else /* !defined(HAVE_LD_PIE) */
#define STARTFILE_SPEC \
  "%{!shared: %{pg|p|profile:gcrt1.o%s;:crt1.o%s}} \
   crti.o%s %{static:crtbeginT.o%s;shared|pie:crtbeginS.o%s;:crtbegin.o%s}"
#endif

/* Objects automatically appended to the link link command line. */
#undef  ENDFILE_SPEC
#define ENDFILE_SPEC "%{shared|pie:crtendS.o%s;:crtend.o%s} crtn.o%s"

/* Handle the mutual dependencies between libpthread and libc. */
#undef LIB_SPEC
#define LIB_SPEC "--start-group %{pthread:}-lpthread -lc --end-group"

/* Define relevant macros for Sortix. */
#undef  TARGET_OS_CPP_BUILTINS
#define TARGET_OS_CPP_BUILTINS()   \
do {                               \
  builtin_define_std("sortix");    \
  builtin_define_std("unix");      \
  builtin_assert("system=sortix"); \
  builtin_assert("system=unix");   \
  builtin_assert("system=posix");  \
} while(0);
